package com.eactive.eai.agent.c2rservice;

import java.util.Vector;

import com.eactive.eai.agent.command.Command;
import com.eactive.eai.agent.command.CommandException;
import com.eactive.eai.common.c2rservice.C2RServiceManager;
import com.eactive.eai.common.util.Logger;

public class ReloadC2RServiceListCommand extends Command {
	private static final long serialVersionUID = 1L;

	public ReloadC2RServiceListCommand() {
		super("ReloadC2RServiceListCommand");
	}

	public Object execute() throws CommandException {
		Logger logger = Logger.getLogger(Logger.LOGGER_DEFAULT);
		if (logger.isInfo())
			logger.info(this.name + " is executed");

		if (!(args instanceof Vector)) {
			String rspErrorCode = "RECEAIMCM001";
			String msg = makeException(rspErrorCode, null);
			if (logger.isError())
				logger.error(msg);
			throw new CommandException(msg);
		}

		C2RServiceManager manager = C2RServiceManager.getInstance();
		try {
			Vector messageVt = (Vector) args;
			String key = "";
			for (int i = 0; i < messageVt.size(); i++) {
				key = (String) messageVt.get(i);

				if (key != null) {
					manager.reload(key);
					if (logger.isWarn())
						logger.warn(this.name + "] " + key + " Reload.");
				}
			}
		} catch (Exception e) {
			String rspErrorCode = "RECEAIMCM002";
			String msg = makeException(rspErrorCode, e);
			if (logger.isError())
				logger.error(msg, e);
			throw new CommandException(msg);
		}
		return "success";

	}

}
